export class Timer {
    constructor() {
        this._state = { _last: 0, _start: 0, _time: 0 };
    }
    static get time() {
        return this._staticTimer._state._time;
    }
    get time() {
        return this._state._time;
    }
    static now() {
        return this._staticTimer.now();
    }
    now() {
        if (typeof (performance) !== "undefined") {
            return performance.now();
        }
        else {
            const hrTime = process.hrtime();
            return hrTime[0] * 1000 + (hrTime[1] / 1e6);
        }
    }
    static start() {
        return this._staticTimer.start();
    }
    start() {
        const now = this.now();
        this._state._start = this._state._last = now;
        this._state._time = 0;
        return now;
    }
    static stop() {
        return this._staticTimer.stop();
    }
    stop() {
        const now = this.now();
        this._state._last = now;
        return this._state._time = now - this._state._start;
    }
}
Timer._staticTimer = new Timer();
//# sourceMappingURL=Timer.js.map